package com.lzmispt.data.resource.service.metadata.impl;

package .tmp;

import com.alibaba.fastjson.JSON;
import com.alibaba.nacos.common.utils.CollectionUtils;
import com.lzmispt.core.entity.dto.querymodel.QueryModelDTO;
import com.lzmispt.core.entity.vo.user.UserVO;
import com.lzmispt.data.center.entity.dto.resource.metadata.EntityItemInfoSearchDTO;
import com.lzmispt.data.center.entity.dto.version.PublishEntityConfig;
import com.lzmispt.data.center.entity.enums.StatusCodeEnum;
import com.lzmispt.data.center.entity.vo.resource.file.FileInfoFieldVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.MetadataFieldVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.MetadataEntityWithElementVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.MetadataFieldWithElementVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.MetadataItemAndValueVO;
import com.lzmispt.data.center.entity.vo.standard.version.VersionContentVO;
import com.lzmispt.data.resource.client.CoreClient;
import com.lzmispt.data.resource.client.DataStandardClient;
import com.lzmispt.data.resource.entity.dto.file.GetFileInfoFieldListDTO;
import com.lzmispt.data.resource.entity.dto.metadata.BatchEditDataItemsDTO;
import com.lzmispt.data.resource.entity.dto.metadata.DragSortMetaDataInfoItemDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataEntityDTO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataEntityInfoItemPO;
import com.lzmispt.data.resource.manager.metadata.MetadataManager;
import com.lzmispt.data.resource.service.metadata.IInfoItem;
import com.lzmispt.data.resource.service.metadata.impl.InfoItemManager;
import com.lzmispt.dcbase.ServiceUtil;
import com.lzmispt.dcbase.dcconst.DCConst;
import com.lzmispt.framework.entity.entity.ResultEntity;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

@Service
public class StandardInfoItemImpl extends InfoItemManager {
  @Autowired
  private DataStandardClient dataStandardClient;
  
  @Autowired
  CoreClient client;
  
  public String getDefaultCode() {
    return "Standard";
  }
  
  public ResultEntity<Boolean> batchEditDataItem(BatchEditDataItemsDTO batcheditdataitemsdto, String tokenId) {
    return null;
  }
  
  public ResultEntity<List<MetadataFieldVO>> getInfoItemList(EntityItemInfoSearchDTO entityItemInfoSearchDTO, String platCode, String tokenId) {
    List<MetadataFieldVO> metadataFieldVOList = new ArrayList<>();
    if (!StringUtils.isEmpty(entityItemInfoSearchDTO.getEntityId())) {
      ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectEntityByEntityId(entityItemInfoSearchDTO.getEntityId(), entityItemInfoSearchDTO.getIsResources(), platCode, tokenId);
      if (resAndDataEntityDTO == null)
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_NO_FOUND_DATA_RESOURCE_ENTITY.getCode()), StatusCodeEnum.DATA_RESOURCE_NO_FOUND_DATA_RESOURCE_ENTITY.getMessage()); 
      ResultEntity<MetadataItemAndValueVO> metadataItemAndValueVOResultEntity = ((IInfoItem)ServiceUtil.getInfoItemManager(platCode, IInfoItem.class)).getInfoItems(entityItemInfoSearchDTO);
      if (metadataItemAndValueVOResultEntity != null && metadataItemAndValueVOResultEntity.getObj() != null && ((MetadataItemAndValueVO)metadataItemAndValueVOResultEntity.getObj()).getData() != null)
        for (int i = 0; i < ((MetadataItemAndValueVO)metadataItemAndValueVOResultEntity.getObj()).getData().size(); i++) {
          Map<String, Object> infoItem = ((MetadataItemAndValueVO)metadataItemAndValueVOResultEntity.getObj()).getData().get(i);
          if (infoItem != null) {
            MetadataEntityInfoItemPO metadataEntityInfoItemPO = this.metadataField.metadataFieldToInfoItem(infoItem);
            MetadataFieldVO metadataFieldVO = new MetadataFieldVO();
            BeanUtils.copyProperties(metadataEntityInfoItemPO, metadataFieldVO);
            metadataFieldVOList.add(metadataFieldVO);
          } 
        }  
    } 
    return ResultEntity.successMessage(metadataFieldVOList);
  }
  
  public ResultEntity<Boolean> dragMetadataInfoItem(DragSortMetaDataInfoItemDTO dataInfoItemDTO, String platCode, String tokenId) {
    Boolean flag = Boolean.valueOf(false);
    if (!StringUtils.isEmpty(dataInfoItemDTO.getEntityId())) {
      ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectEntityByEntityId(dataInfoItemDTO.getEntityId(), dataInfoItemDTO.getIsResources(), platCode, tokenId);
      ResAndDataEntityDTO resAndDataEntityDTO1 = resAndDataEntityDTO;
      if (resAndDataEntityDTO1 == null)
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_NO_FOUND_DATA_RESOURCE_ENTITY.getCode()), StatusCodeEnum.DATA_RESOURCE_NO_FOUND_DATA_RESOURCE_ENTITY.getMessage()); 
      EntityItemInfoSearchDTO searchDTO = new EntityItemInfoSearchDTO();
      searchDTO.setEntityId(dataInfoItemDTO.getEntityId());
      searchDTO.setPlatCode(platCode);
      List<Long> ids = dataInfoItemDTO.getIds();
      if (CollectionUtils.isNotEmpty(ids)) {
        ResultEntity<List<MetadataFieldWithElementVO>> saveFieldsRet = MetadataManager.saveFieldData(resAndDataEntityDTO, tokenId, platCode, null, "lzdc_sys_serial_number", ids, dataInfoItemDTO.getIsResources());
        flag = Boolean.valueOf(saveFieldsRet.getCode().equals(DCConst.FALSE));
      } 
      if (!flag.booleanValue())
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_NO_FOUND_DATA_RESOURCE_ENTITY.getCode()), StatusCodeEnum.DATA_RESOURCE_NO_FOUND_DATA_RESOURCE_ENTITY.getMessage()); 
    } 
    return ResultEntity.successMessage(flag);
  }
  
  public ResultEntity<List<FileInfoFieldVO>> getFileInfoItemList(GetFileInfoFieldListDTO entityItemInfoSearchDTO, String platCode, String tokenId) {
    return null;
  }
  
  public ResultEntity<Boolean> dragFileInfoItem(DragSortMetaDataInfoItemDTO dataInfoItemDTO, String platCode, String tokenId) {
    return null;
  }
  
  public ResultEntity getDataFieldMetadataVersions(QueryModelDTO queryModelDTO, String platCode, String tokenId) {
    ResultEntity<List<VersionContentVO>> dataFieldMetadataVersions = this.dataStandardClient.getVersionContentVOList(queryModelDTO, platCode, tokenId);
    if (DCConst.FALSE.equals(dataFieldMetadataVersions.getCode()) && dataFieldMetadataVersions.getObj() != null)
      for (VersionContentVO versionContentVO : dataFieldMetadataVersions.getObj()) {
        UserVO userVO = (UserVO)this.client.getUserInfoById(versionContentVO.getUserIdRecord(), versionContentVO.getOrgIdRecord(), tokenId).getObj();
        versionContentVO.setUserName(userVO.getUserName());
        if (versionContentVO.getPublishId() == null) {
          List<Long> fieldIds = new ArrayList<>();
          fieldIds.add(versionContentVO.getDataItemId());
          MetadataFieldWithElementVO field = ((List<MetadataFieldWithElementVO>)this.dataStandardClient.getFieldWithElementByIds(fieldIds, DCConst.DataResourceCategory.DATA, platCode, tokenId).getObj()).get(0);
          MetadataEntityWithElementVO entity = (MetadataEntityWithElementVO)this.dataStandardClient.getEntityWithElementByEntityId(field.getEntityId(), DCConst.DataResourceCategory.DATA, platCode, tokenId).getObj();
          PublishEntityConfig publishEntityConfig = new PublishEntityConfig();
          publishEntityConfig.setEntityId(field.getEntityId().toString());
          publishEntityConfig.setBusinessEntityId(entity.getBusinessId().toString());
          List<PublishEntityConfig> publishEntityConfigList = new ArrayList<>();
          publishEntityConfigList.add(publishEntityConfig);
          versionContentVO.setPublishConfig(JSON.toJSONString(publishEntityConfigList));
        } 
      }  
    return dataFieldMetadataVersions;
  }
}
